#include <math.h>
#include "qnrutil.h"

#define TINY 1.0e-20

double det(double **aa, int n)
{
        int i, imax, j, k;
        double d, big, dum, sum, tem;
        double *vv;

        vv=vector(1,n);
        d=1.0;
        for (i=1;i<=n;i++) {
                big=0.0;
                for (j=1;j<=n;j++)
                        if ((tem=fabs(aa[i][j])) > big) big=tem;
                if (big == 0.0) nrerror ("Singular matrix in routine dim");
        vv[i]=1.0/big;
        }
        for (j=1;j<=n;j++) {
                for (i=1;i<j;i++) {
                        sum=aa[i][j];
                        for (k=1;k<i;k++) sum -= aa[i][k]*aa[k][j];
                        aa[i][j]=sum;
                }
                big=0.0;
                for (i=j;i<=n;i++) {
                        sum=aa[i][j];
                        for (k=1;k<j;k++)
                                sum -= aa[i][k]*aa[k][j];
                        aa[i][j]=sum;
                        if ( (dum=vv[i]*fabs(sum)) >= big) {
                                big=dum;
                                imax=i;
                        }
                }
                if (j != imax) {
                        for (k=1;k<=n;k++) {
                                dum=aa[imax][k];
                                aa[imax][k]=aa[j][k];
                                aa[j][k]=dum;
                        }
                        d = -d;
                        vv[imax]=vv[j];
                }
                if (aa[j][j] == 0.0) aa[j][j]=TINY;
                if (j != n) {
                        dum=1.0/(aa[j][j]);
                        for (i=j+1;i<=n;i++) aa[i][j] *= dum;
                }
        }
/* tack on the determinant determination */
        for (j=1;j<=n;j++)
                d *= aa[j][j];

        free_vector(vv,1,n);
        return d;
}

#undef TINY
